	PROGRAM TRANSCK
C
	IMPLICIT NONE
C
	INTEGER NGAUSS, NNU, NTEMP, NVF
      	PARAMETER(NGAUSS=7,NTEMP=16,NNU=44, NVF=5)
C DECLARATION OF THE VARIABLES
	INTEGER IGAUSS, INU, IVF, ITEMP, I1, I2
      	REAL*8 XH2O, L1, T, QH
	REAL*8 CT1, CT2, KSTAR, CX1, CX2
	REAL*8 K1(1:NTEMP,1:NVF,1:NNU,1:NGAUSS)
	REAL*8 DNU1(1:NNU), SIG1(1:NNU), STAU(1:NNU)
	REAL*8 TEMP(1:NTEMP), XGAZ(1:NVF)
      	REAL*8 AMEGA(1:NGAUSS)
      	CHARACTER*72 NAME1, NAME2
	EXTERNAL QH
C GAUSS 7-PTS QUADRATURE COEFFICIENTS
      	DATA AMEGA/
     &	0.45000000E-01,
     &	0.24500000E+00,
     &	0.32000000E+00,
     &	0.24500000E+00,
     &	0.56111111E-01,
     &	0.51248583E-01,
     &	0.37640306E-01/
C TEMPERATURE AND VOLUMIC FRACTION OF CALCULATION
	DATA TEMP / 300., 375., 425., 500., 600., 700., 800., 900.,
     &	            1100., 1300., 1500., 1700., 1900.,
     &	            2100., 2300., 2500. /
	DATA XGAZ / 0.01, 0.1, 0.4, 0.66, 1. /
C ENTERING THE DATAS
	WRITE (6,*) 'ENTER XH2O, T (K), L (CM) :'
	READ (5,*) XH2O, T, L1
C	WRITE (6,*) 'ENTER THE NAME OF THE CK DATA FILE :'
C	READ (5,'(A72)') NAME1
	NAME1 = 'CKH2O'
	WRITE (6,*) 'ENTER THE NAME OF THE RESULT FILE :'
	READ (5,'(A72)') NAME2
C READING THE CK DATA FILE
      	OPEN(UNIT=1,FILE=NAME1,STATUS='OLD')
	DO INU=1, NNU
	READ (1,*) SIG1(INU), DNU1(INU)
	  DO IGAUSS=1, NGAUSS
	    READ (1,*)
	    DO IVF=1, NVF
	      READ (1,2000) (K1(ITEMP,IVF,INU,IGAUSS),ITEMP=1,NTEMP)
	    ENDDO
	  ENDDO
	ENDDO
2000	FORMAT (3(5(1PE12.6,1X),/),1PE12.6)
	CLOSE (1)
C INTERPOLATION IN TEMPERATURE
	IF ((T.LT.TEMP(1)).OR.(T.GT.TEMP(NTEMP))) THEN
	  WRITE (6,*) 'ERROR : THE TEMPERATURE IS EITHER TOO LOW'
	  WRITE (6,*) 'OR TOO HIGH'
	  STOP
	ENDIF
	I1 = 1
100	CONTINUE
	IF (T.GT.TEMP(I1+1)) THEN 
	  I1 = I1 + 1
	  GOTO 100
	ENDIF
	CT1 = (TEMP(I1+1)-T)/(TEMP(I1+1)-TEMP(I1))
	CT2 = (T-TEMP(I1))/(TEMP(I1+1)-TEMP(I1))
C INTERPOLATION IN VOLUMIC FRACTION
	IF ((XH2O.LT.XGAZ(1)).OR.(XH2O.GT.XGAZ(NVF))) THEN
	  WRITE (6,*) 'ERROR : THE VOLUMIC FRACTION IS EITHER TOO LOW'
	  WRITE (6,*) 'OR TOO HIGH'
	  STOP
	ENDIF
	I2 = 1
200	CONTINUE
	IF (XH2O.GT.XGAZ(I2+1)) THEN 
	  I2 = I2 + 1
	  GOTO 200
	ENDIF
	CX1 = (XGAZ(I2+1)-XH2O)/(XGAZ(I2+1)-XGAZ(I2))
	CX2 = (XH2O-XGAZ(I2))/(XGAZ(I2+1)-XGAZ(I2))
C CALCULATING THE TRANSMITTIVITY
     	OPEN(UNIT=7,FILE=NAME2)
	DO INU=1, NNU
	  STAU(IGAUSS) = 0.D0
	  DO IGAUSS=1, NGAUSS
	    KSTAR = CT1*CX1*K1(I1,I2,INU,IGAUSS) +
     &	            CT2*CX1*K1(I1+1,I2,INU,IGAUSS) +
     &	            CT1*CX2*K1(I1,I2+1,INU,IGAUSS) +
     &	            CT2*CX2*K1(I1+1,I2+1,INU,IGAUSS)
	    KSTAR = KSTAR*XH2O/(T*QH(T))
	    STAU(INU) = STAU(INU)+ AMEGA(IGAUSS)*DEXP(-KSTAR*L1)
	  ENDDO
	  WRITE (7,1000) DNU1(INU), SIG1(INU), STAU(INU)
	ENDDO
	CLOSE (7)
1000	FORMAT(0PF5.1,1X,0PF6.1,1X,1PE10.4)     
	END
CCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C PARTITION FUNCTION OF H2O C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      	REAL*8 FUNCTION QC(T)
C
	IMPLICIT NONE
C DECLARATION OF THE VARIABLES
	INTEGER K, IK
	REAL*8 CC, T, RES
      	REAL*8 CH2OA1(4),CH2OB1(4),H2OA(4),H2OB(4)
C DATAS
      	DATA CH2OA1/-2.154443478E0,0.9670123486E0,-0.8082674825E-03,
     &	0.2806562032E-05/
      	DATA CH2OB1/-351.7866975E0,2.779333185E0,-0.3673680835E-02,
     &	0.4090051841E-05/
C CASE OF H2O (4TH DEGREE POLYNOM FITTED ON EXACT CALC FROM ROTHMAN'S
C LEVELS. 1% ACCURACY IN THE 150-3000 K RANGE)
      	DO IK=1,4
      	  H2OA(IK)=CH2OA1(IK)
    	  H2OB(IK)=CH2OB1(IK)
	ENDDO
      	CC=1./T
      	RES=0.
      	DO K=1,4
      	  CC=CC*T
      	  IF(T.LT.405.) THEN
            RES=RES+H2OA(K)*CC
      	  ELSE
      	    RES=RES+H2OB(K)*CC
      	  ENDIF
	ENDDO
      	QC=RES
      	RETURN
      	END
CCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C PARTITION FUNCTION OF H2O C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      REAL*8 FUNCTION QH(T)
      implicit REAL*8 (a-h,o-z)
      dimension ch2oa(4),ch2ob(4)
      data ch2oa/-3.697248813d0,0.2601622207d0,0.1358654145d-02,
     ,-0.6749557714d-06/
      data ch2ob/-49.01925676d0,0.6271879739d0,0.3293104256d-03,
     ,0.3447216719d-06/
      cc=1.d0/t
      res=0.
      do 81 k=1,4
      cc=cc*t
      if(t.lt.405.d0) then
      res=res+ch2oa(k)*cc
      else
      res=res+ch2ob(k)*cc
      endif
81    continue
      QH = res
      return
      end
